grk::PacketIter Struct Reference

Packet iterator. More...

`#include <PacketIter.h>`

## Public Member Functions

| PacketIter ()
| ~PacketIter ()
void | init (PacketManager *packetMan, uint32_t pino, TileCodingParams *tcp, grk_rect32 tileBounds, bool compression, uint8_t max_res, uint64_t max_precincts, uint32_t *resolutionPrecinctGrid, uint32_t **precinctByComponent)
void | printStaticState (void)
void | printDynamicState (void)
void | enableTilePartGeneration (uint32_t pino, bool first_poc_tile_part, uint32_t tppos)
| Modify the packet iterator for enabling tile part generation.
bool | genPrecinctInfoOPT ()
void | genPrecinctInfo ()
void | genPrecinctInfo (PiComp *comp, PiResolution *res, uint8_t resNumber)
uint8_t * | get_include (uint16_t layerIndex)
bool | update_include (void)
void | destroy_include (void)
bool | next (SparseBuffer *src)
| Modify the packet iterator to point to the next packet.
GRK_PROG_ORDER | getProgression (void) const
uint16_t | getCompno (void) const
uint8_t | getResno (void) const
uint64_t | getPrecinctIndex (void) const
uint16_t | getLayno (void) const

## Private Member Functions

void | update_dxy (void)
bool | checkForRemainingValidProgression (int32_t prog, uint32_t pino, const char *progString)
| Check if there is a remaining valid progression order.
bool | genPrecinctY0Grid (ResPrecinctInfo *rpInfo)
bool | genPrecinctX0Grid (ResPrecinctInfo *rpInfo)
void | genPrecinctY0GridRPCL_OPT (ResPrecinctInfo *rpInfo)
void | genPrecinctX0GridRPCL_OPT (ResPrecinctInfo *rpInfo)
bool | genPrecinctX0GridPCRL_OPT (ResPrecinctInfo *rpInfo)
bool | genPrecinctY0GridPCRL_OPT (ResPrecinctInfo *rpInfo)
bool | precInfoCheck (ResPrecinctInfo *rpInfo)
void | generatePrecinctIndex (void)
bool | validatePrecinct (void)
void | update_dxy_for_comp (PiComp *comp, bool updateActive)
bool | isWholeTile (void)
bool | next_cprl (SparseBuffer *src)
| Get next packet in component-precinct-resolution-layer order.
bool | next_cprlOPT (SparseBuffer *src)
bool | next_pcrl (SparseBuffer *src)
| Get next packet in precinct-component-resolution-layer order.
bool | next_pcrlOPT (SparseBuffer *src)
bool | next_lrcp (SparseBuffer *src)
| Get next packet in layer-resolution-component-precinct order.
bool | next_lrcpOPT (SparseBuffer *src)
bool | next_rlcp (SparseBuffer *src)
| Get next packet in resolution-layer-component-precinct order.
bool | next_rlcpOPT (SparseBuffer *src)
bool | next_rpcl (SparseBuffer *src)
| Get next packet in resolution-precinct-component-layer order.
bool | next_rpclOPT (SparseBuffer *src)
bool | skipPackets (SparseBuffer *src, uint64_t numPackets)

## Private Attributes

uint16_t | compno
uint8_t | resno
uint64_t | precinctIndex
uint16_t | layno
grk_progression | prog
uint16_t | numcomps
PiComp * | comps
uint64_t | x
| packet coordinates
uint64_t | y
uint32_t | dx
| component sub-sampling
uint32_t | dy
uint32_t | dxActive
uint32_t | dyActive
bool | incrementInner
PacketManager * | packetManager
uint8_t | maxNumDecompositionResolutions
bool | singleProgression_
bool | compression_
ResPrecinctInfo * | precinctInfoOPT_
uint32_t | px0grid_
uint32_t | py0grid_
bool | skippedLeft_

## Detailed Description

Packet iterator.

## Constructor & Destructor Documentation

## PacketIter()

grk::PacketIter::PacketIter | ( |  | ) |

References grk::grk_read(), and prog.

## ~PacketIter()

grk::PacketIter::~PacketIter | ( |  | ) |

References comps, and precinctInfoOPT_.

## Member Function Documentation

## checkForRemainingValidProgression()

bool grk::PacketIter::checkForRemainingValidProgression | ( | int32_t | prog,
|  | uint32_t | pino,
|  | const char * | progString
| ) |  |

private

Check if there is a remaining valid progression order.

References checkForRemainingValidProgression(), grk::PacketManager::getCodingParams(), grk::TileProcessor::getIndex(), grk::PacketManager::getTileProcessor(), GRK_LRCP, grk::grk_read(), GRK_RLCP, packetManager, prog, and grk::CodingParams::tcps.

Referenced by checkForRemainingValidProgression(), and enableTilePartGeneration().

## destroy_include()

void grk::PacketIter::destroy_include | ( | void |  | ) |

References grk::IncludeTracker::clear(), grk::PacketManager::getIncludeTracker(), and packetManager.

Referenced by grk::PacketManager::~PacketManager().

## enableTilePartGeneration()

void grk::PacketIter::enableTilePartGeneration | ( | uint32_t | pino,
|  | bool | first_poc_tile_part,
|  | uint32_t | tppos
| ) |  |

Modify the packet iterator for enabling tile part generation.

Parameters

  pino | packet iterator number
  first_poc_tile_part | true for first POC tile part
  tppos | The position of the tile part flag in the progression order

References checkForRemainingValidProgression(), _grk_progression::compE, _grk_progression::compS, grk::CodeStreamCompress::convertProgressionOrder(), grk::FINAL_PASS, grk::PacketManager::getCodingParams(), grk::TileProcessor::getIndex(), grk::PacketManager::getT2Mode(), grk::PacketManager::getTileProcessor(), GRK_IS_CINEMA, GRK_IS_IMF, GRK_LRCP, grk::grk_read(), GRK_RLCP, _grk_progression::layE, _grk_progression::layS, packetManager, _grk_progression::precE, _grk_progression::precS, prog, _grk_progression::progression, _grk_progression::resE, _grk_progression::resS, grk::CodingParams::tcps, _grk_progression::tx0, _grk_progression::tx1, _grk_progression::ty0, and _grk_progression::ty1.

## generatePrecinctIndex()

void grk::PacketIter::generatePrecinctIndex | ( | void |  | ) |

private

References compno, comps, grk::grk_read(), grk::PiResolution::precinctGridWidth, precinctIndex, px0grid_, py0grid_, resno, and grk::PiComp::resolutions.

Referenced by next_cprl(), next_pcrl(), and next_rpcl().

## genPrecinctInfo() [1/2]

void grk::PacketIter::genPrecinctInfo | ( |  | ) |

References comps, genPrecinctInfo(), genPrecinctInfoOPT(), grk::grk_read(), numcomps, and grk::PiComp::resolutions.

Referenced by genPrecinctInfo(), and init().

## genPrecinctInfo() [2/2]

void grk::PacketIter::genPrecinctInfo | ( | PiComp * | comp,
|  | PiResolution * | res,
|  | uint8_t | resNumber
| ) |  |

References compression_, grk::PacketManager::getTileBounds(), grk::PacketManager::getTileProcessor(), grk::TileProcessor::getUnreducedTileWindow(), grk::grk_read(), isWholeTile(), and packetManager.

## genPrecinctInfoOPT()

bool grk::PacketIter::genPrecinctInfoOPT | ( | void |  | ) |

References compno, compression_, comps, grk::PiComp::dx, grk::PiComp::dy, grk::PacketManager::getTileBounds(), grk::PacketManager::getTileProcessor(), grk::TileProcessor::getUnreducedTileWindow(), GRK_CPRL, GRK_LRCP, GRK_PCRL, grk::grk_read(), GRK_RLCP, GRK_RPCL, isWholeTile(), numcomps, grk::PiComp::numresolutions, packetManager, precinctInfoOPT_, grk::PiResolution::precWidthExp, prog, _grk_progression::progression, resno, grk::PiComp::resolutions, and singleProgression_.

Referenced by genPrecinctInfo().

## genPrecinctX0Grid()

bool grk::PacketIter::genPrecinctX0Grid | ( | ResPrecinctInfo * | rpInfo | ) |

private

References grk::ceildiv(), grk::floordivpow2(), grk::PacketManager::getTileBounds(), grk::grk_read(), packetManager, px0grid_, x, and grk::grk_rect< T >::x0.

Referenced by validatePrecinct().

## genPrecinctX0GridPCRL_OPT()

bool grk::PacketIter::genPrecinctX0GridPCRL_OPT | ( | ResPrecinctInfo * | rpInfo | ) |

private

References grk::ceildivpow2(), grk::grk_read(), px0grid_, and x.

Referenced by next_cprlOPT(), and next_pcrlOPT().

## genPrecinctX0GridRPCL_OPT()

void grk::PacketIter::genPrecinctX0GridRPCL_OPT | ( | ResPrecinctInfo * | rpInfo | ) |

private

References grk::ceildivpow2(), grk::grk_read(), px0grid_, and x.

Referenced by next_rpclOPT().

## genPrecinctY0Grid()

bool grk::PacketIter::genPrecinctY0Grid | ( | ResPrecinctInfo * | rpInfo | ) |

private

References grk::ceildiv(), grk::floordivpow2(), grk::PacketManager::getTileBounds(), grk::grk_read(), packetManager, py0grid_, y, and grk::grk_rect< T >::y0.

Referenced by validatePrecinct().

## genPrecinctY0GridPCRL_OPT()

bool grk::PacketIter::genPrecinctY0GridPCRL_OPT | ( | ResPrecinctInfo * | rpInfo | ) |

private

References grk::ceildivpow2(), grk::grk_read(), py0grid_, and y.

Referenced by next_cprlOPT(), and next_pcrlOPT().

## genPrecinctY0GridRPCL_OPT()

void grk::PacketIter::genPrecinctY0GridRPCL_OPT | ( | ResPrecinctInfo * | rpInfo | ) |

private

References grk::ceildivpow2(), grk::grk_read(), py0grid_, and y.

Referenced by next_rpclOPT().

## get_include()

uint8_t * grk::PacketIter::get_include | ( | uint16_t | layerIndex | ) |

References grk::IncludeTracker::get_include(), grk::PacketManager::getIncludeTracker(), grk::grk_read(), packetManager, and resno.

## getCompno()

uint16_t grk::PacketIter::getCompno | ( | void |  | ) | const

References compno.

## getLayno()

uint16_t grk::PacketIter::getLayno | ( | void |  | ) | const

References layno.

## getPrecinctIndex()

uint64_t grk::PacketIter::getPrecinctIndex | ( | void |  | ) | const

References precinctIndex.

## getProgression()

GRK_PROG_ORDER grk::PacketIter::getProgression | ( | void |  | ) | const

References prog, and _grk_progression::progression.

## getResno()

uint8_t grk::PacketIter::getResno | ( | void |  | ) | const

References resno.

## init()

void grk::PacketIter::init | ( | PacketManager * | packetMan,
|  | uint32_t | pino,
|  | TileCodingParams * | tcp,
|  | grk_rect32 | tileBounds,
|  | bool | compression,
|  | uint8_t | max_res,
|  | uint64_t | max_precincts,
|  | uint32_t * | resolutionPrecinctGrid,
|  | uint32_t ** | precinctByComponent
| ) |  |

References _grk_progression::compE, compno, compression_, _grk_progression::compS, comps, genPrecinctInfo(), grk::TileProcessor::getMaxNumDecompressResolutions(), grk::PacketManager::getNumProgressions(), grk::TileProcessor::getTileCodingParams(), grk::PacketManager::getTileProcessor(), GRK_CPRL, GRK_LRCP, GRK_PCRL, grk::grk_read(), GRK_RLCP, GRK_RPCL, grk::ResPrecinctInfo::innerPrecincts_, _grk_progression::layE, _grk_progression::layS, maxNumDecompositionResolutions, numcomps, grk::TileCodingParams::numLayersToDecompress, grk::PiComp::numresolutions, packetManager, _grk_progression::precE, precinctInfoOPT_, _grk_progression::precS, grk::PiResolution::precWidthExp, prog, _grk_progression::progression, _grk_progression::resE, resno, grk::PiComp::resolutions, _grk_progression::resS, singleProgression_, _grk_progression::tx0, _grk_progression::tx1, _grk_progression::ty0, _grk_progression::ty1, update_dxy(), x, and y.

Referenced by grk::PacketManager::PacketManager().

## isWholeTile()

bool grk::PacketIter::isWholeTile | ( | void |  | ) |

private

References compression_, grk::TileProcessor::cp_, grk::PacketManager::getTileProcessor(), packetManager, and grk::CodingParams::wholeTileDecompress_.

Referenced by genPrecinctInfo(), genPrecinctInfoOPT(), next_cprlOPT(), next_pcrlOPT(), next_rpclOPT(), and validatePrecinct().

## next()

bool grk::PacketIter::next | ( | SparseBuffer * | src | ) |

Modify the packet iterator to point to the next packet.

Returns
  false if pi pointed to the final packet, otherwise true

References GRK_CPRL, GRK_LRCP, GRK_PCRL, grk::grk_read(), GRK_RLCP, GRK_RPCL, next_cprl(), next_lrcp(), next_pcrl(), next_rlcp(), next_rpcl(), prog, and _grk_progression::progression.

## next_cprl()

bool grk::PacketIter::next_cprl | ( | SparseBuffer * | src | ) |

private

Get next packet in component-precinct-resolution-layer order.

Returns
  returns false if pi pointed to the final packet, otherwise true

References _grk_progression::compE, compno, comps, dx, dxActive, dy, dyActive, generatePrecinctIndex(), grk::grk_read(), incrementInner, _grk_progression::layE, layno, _grk_progression::layS, next_cprlOPT(), precinctInfoOPT_, prog, _grk_progression::resE, resno, _grk_progression::resS, _grk_progression::tx0, _grk_progression::tx1, _grk_progression::ty0, _grk_progression::ty1, update_dxy_for_comp(), update_include(), validatePrecinct(), x, and y.

Referenced by next().

## next_cprlOPT()

bool grk::PacketIter::next_cprlOPT | ( | SparseBuffer * | src | ) |

private

References _grk_progression::compE, compno, comps, dx, dy, genPrecinctX0GridPCRL_OPT(), genPrecinctY0GridPCRL_OPT(), grk::grk_read(), incrementInner, isWholeTile(), _grk_progression::layE, layno, _grk_progression::layS, precinctIndex, precinctInfoOPT_, precInfoCheck(), prog, px0grid_, py0grid_, _grk_progression::resE, resno, grk::PiComp::resolutions, _grk_progression::resS, skipPackets(), _grk_progression::tx0, _grk_progression::ty0, x, and y.

Referenced by next_cprl().

## next_lrcp()

bool grk::PacketIter::next_lrcp | ( | SparseBuffer * | src | ) |

private

Get next packet in layer-resolution-component-precinct order.

Returns
  returns false if pi pointed to the final packet, otherwise true

References _grk_progression::compE, compno, _grk_progression::compS, comps, grk::grk_read(), incrementInner, _grk_progression::layE, layno, next_lrcpOPT(), grk::PiComp::numresolutions, grk::PiResolution::precinctGridWidth, precinctIndex, precinctInfoOPT_, _grk_progression::precS, prog, _grk_progression::resE, resno, grk::PiComp::resolutions, _grk_progression::resS, and update_include().

Referenced by next().

## next_lrcpOPT()

bool grk::PacketIter::next_lrcpOPT | ( | SparseBuffer * | src | ) |

private

References _grk_progression::compE, compno, _grk_progression::compS, grk::grk_read(), incrementInner, _grk_progression::layE, layno, grk::ResPrecinctInfo::numPrecincts_, precinctIndex, precinctInfoOPT_, precInfoCheck(), _grk_progression::precS, prog, _grk_progression::resE, resno, and _grk_progression::resS.

Referenced by next_lrcp().

## next_pcrl()

bool grk::PacketIter::next_pcrl | ( | SparseBuffer * | src | ) |

private

Get next packet in precinct-component-resolution-layer order.

Returns
  returns false if pi pointed to the final packet, otherwise true

References _grk_progression::compE, compno, _grk_progression::compS, dx, dxActive, dy, dyActive, generatePrecinctIndex(), grk::PacketManager::getTileProcessor(), grk::TileProcessor::getUnreducedTileWindow(), grk::grk_read(), incrementInner, _grk_progression::layE, layno, _grk_progression::layS, next_pcrlOPT(), packetManager, precinctInfoOPT_, prog, _grk_progression::resE, resno, _grk_progression::resS, singleProgression_, _grk_progression::tx0, _grk_progression::tx1, _grk_progression::ty1, update_include(), validatePrecinct(), x, and y.

Referenced by next().

## next_pcrlOPT()

bool grk::PacketIter::next_pcrlOPT | ( | SparseBuffer * | src | ) |

private

References _grk_progression::compE, compno, _grk_progression::compS, comps, dx, dy, genPrecinctX0GridPCRL_OPT(), genPrecinctY0GridPCRL_OPT(), grk::grk_read(), incrementInner, isWholeTile(), _grk_progression::layE, layno, _grk_progression::layS, precinctIndex, precinctInfoOPT_, precInfoCheck(), prog, px0grid_, py0grid_, _grk_progression::resE, resno, grk::PiComp::resolutions, _grk_progression::resS, x, and y.

Referenced by next_pcrl().

## next_rlcp()

bool grk::PacketIter::next_rlcp | ( | SparseBuffer * | src | ) |

private

Get next packet in resolution-layer-component-precinct order.

Returns
  returns false if pi pointed to the final packet, otherwise true

References _grk_progression::compE, compno, _grk_progression::compS, comps, grk::grk_read(), incrementInner, _grk_progression::layE, layno, _grk_progression::layS, next_rlcpOPT(), grk::PiComp::numresolutions, grk::PiResolution::precinctGridWidth, precinctIndex, precinctInfoOPT_, _grk_progression::precS, prog, _grk_progression::resE, resno, grk::PiComp::resolutions, and update_include().

Referenced by next().

## next_rlcpOPT()

bool grk::PacketIter::next_rlcpOPT | ( | SparseBuffer * | src | ) |

private

References _grk_progression::compE, compno, _grk_progression::compS, grk::grk_read(), incrementInner, _grk_progression::layE, layno, _grk_progression::layS, grk::ResPrecinctInfo::numPrecincts_, precinctIndex, precinctInfoOPT_, precInfoCheck(), _grk_progression::precS, prog, _grk_progression::resE, and resno.

Referenced by next_rlcp().

## next_rpcl()

bool grk::PacketIter::next_rpcl | ( | SparseBuffer * | src | ) |

private

Get next packet in resolution-precinct-component-layer order.

Returns
  returns false if pi pointed to the final packet, otherwise true

References _grk_progression::compE, compno, _grk_progression::compS, comps, dx, dxActive, dy, dyActive, generatePrecinctIndex(), grk::grk_read(), incrementInner, _grk_progression::layE, layno, _grk_progression::layS, next_rpclOPT(), precinctInfoOPT_, prog, _grk_progression::resE, resno, grk::PiComp::resolutions, _grk_progression::tx0, _grk_progression::tx1, _grk_progression::ty0, _grk_progression::ty1, update_include(), validatePrecinct(), x, and y.

Referenced by next().

## next_rpclOPT()

bool grk::PacketIter::next_rpclOPT | ( | SparseBuffer * | src | ) |

private

References _grk_progression::compE, compno, _grk_progression::compS, genPrecinctX0GridRPCL_OPT(), genPrecinctY0GridRPCL_OPT(), grk::grk_read(), incrementInner, isWholeTile(), _grk_progression::layE, layno, _grk_progression::layS, maxNumDecompositionResolutions, precinctIndex, precinctInfoOPT_, precInfoCheck(), prog, px0grid_, py0grid_, _grk_progression::resE, resno, skipPackets(), skippedLeft_, grk::ResPrecinctInfo::winPrecPRJ, x, y, and grk::grk_rect< T >::y0.

Referenced by next_rpcl().

## precInfoCheck()

bool grk::PacketIter::precInfoCheck | ( | ResPrecinctInfo * | rpInfo | ) |

private

References comps, grk::grk_read(), grk::PiComp::numresolutions, resno, and grk::PiComp::resolutions.

Referenced by next_cprlOPT(), next_lrcpOPT(), next_pcrlOPT(), next_rlcpOPT(), and next_rpclOPT().

## printDynamicState()

void grk::PacketIter::printDynamicState | ( | void |  | ) |

References compno, grk::GRK_INFO(), grk::grk_read(), layno, precinctIndex, precinctInfoOPT_, resno, x, and y.

## printStaticState()

void grk::PacketIter::printStaticState | ( | void |  | ) |

References _grk_progression::compE, comps, grk::GRK_INFO(), grk::grk_read(), _grk_progression::layE, grk::PiComp::numresolutions, _grk_progression::precE, precinctInfoOPT_, grk::ResPrecinctInfo::print(), prog, _grk_progression::resE, and resno.

## skipPackets()

bool grk::PacketIter::skipPackets | ( | SparseBuffer * | src,
|  | uint64_t | numPackets
| ) |  |

private

References grk::PLCache::getMarkers(), grk::PacketManager::getTileProcessor(), grk::GRK_ERROR(), grk::grk_read(), grk::TileProcessor::packetLengthCache, packetManager, and grk::PLMarkerMgr::pop().

Referenced by next_cprlOPT(), and next_rpclOPT().

## update_dxy()

void grk::PacketIter::update_dxy | ( | void |  | ) |

private

References compno, comps, dx, dxActive, dy, dyActive, grk::grk_read(), numcomps, update_dxy_for_comp(), x, and y.

Referenced by init().

## update_dxy_for_comp()

void grk::PacketIter::update_dxy_for_comp | ( | PiComp * | comp,
|  | bool | updateActive
| ) |  |

private

References dx, dxActive, dy, dyActive, grk::grk_read(), resno, x, and y.

Referenced by next_cprl(), and update_dxy().

## update_include()

bool grk::PacketIter::update_include | ( | void |  | ) |

References compno, grk::PacketManager::getIncludeTracker(), layno, packetManager, precinctIndex, resno, singleProgression_, and grk::IncludeTracker::update().

Referenced by next_cprl(), next_lrcp(), next_pcrl(), next_rlcp(), and next_rpcl().

## validatePrecinct()

bool grk::PacketIter::validatePrecinct | ( | void |  | ) |

private

References compno, compression_, comps, genPrecinctX0Grid(), genPrecinctY0Grid(), grk::PacketManager::getTileBounds(), grk::PacketManager::getTileProcessor(), grk::TileProcessor::getUnreducedTileWindow(), grk::grk_read(), isWholeTile(), packetManager, precinctInfoOPT_, grk::ResPrecinctInfo::precWidthExp, resno, and grk::PiComp::resolutions.

Referenced by next_cprl(), next_pcrl(), and next_rpcl().

## Member Data Documentation

## compno

uint16_t grk::PacketIter::compno

private

Referenced by generatePrecinctIndex(), genPrecinctInfoOPT(), getCompno(), init(), next_cprl(), next_cprlOPT(), next_lrcp(), next_lrcpOPT(), next_pcrl(), next_pcrlOPT(), next_rlcp(), next_rlcpOPT(), next_rpcl(), next_rpclOPT(), printDynamicState(), update_dxy(), update_include(), and validatePrecinct().

## compression_

bool grk::PacketIter::compression_

private

Referenced by genPrecinctInfo(), genPrecinctInfoOPT(), init(), isWholeTile(), and validatePrecinct().

## comps

PiComp* grk::PacketIter::comps

private

Referenced by generatePrecinctIndex(), genPrecinctInfo(), genPrecinctInfoOPT(), init(), next_cprl(), next_cprlOPT(), next_lrcp(), next_pcrlOPT(), next_rlcp(), next_rpcl(), precInfoCheck(), printStaticState(), update_dxy(), validatePrecinct(), and ~PacketIter().

## dx

uint32_t grk::PacketIter::dx

private

component sub-sampling

Referenced by next_cprl(), next_cprlOPT(), next_pcrl(), next_pcrlOPT(), next_rpcl(), update_dxy(), and update_dxy_for_comp().

## dxActive

uint32_t grk::PacketIter::dxActive

private

Referenced by next_cprl(), next_pcrl(), next_rpcl(), update_dxy(), and update_dxy_for_comp().

## dy

uint32_t grk::PacketIter::dy

private

Referenced by next_cprl(), next_cprlOPT(), next_pcrl(), next_pcrlOPT(), next_rpcl(), update_dxy(), and update_dxy_for_comp().

## dyActive

uint32_t grk::PacketIter::dyActive

private

Referenced by next_cprl(), next_pcrl(), next_rpcl(), update_dxy(), and update_dxy_for_comp().

## incrementInner

bool grk::PacketIter::incrementInner

private

Referenced by next_cprl(), next_cprlOPT(), next_lrcp(), next_lrcpOPT(), next_pcrl(), next_pcrlOPT(), next_rlcp(), next_rlcpOPT(), next_rpcl(), and next_rpclOPT().

## layno

uint16_t grk::PacketIter::layno

private

Referenced by getLayno(), next_cprl(), next_cprlOPT(), next_lrcp(), next_lrcpOPT(), next_pcrl(), next_pcrlOPT(), next_rlcp(), next_rlcpOPT(), next_rpcl(), next_rpclOPT(), printDynamicState(), and update_include().

## maxNumDecompositionResolutions

uint8_t grk::PacketIter::maxNumDecompositionResolutions

private

Referenced by init(), and next_rpclOPT().

## numcomps

uint16_t grk::PacketIter::numcomps

private

Referenced by genPrecinctInfo(), genPrecinctInfoOPT(), init(), and update_dxy().

## packetManager

PacketManager* grk::PacketIter::packetManager

private

Referenced by checkForRemainingValidProgression(), destroy_include(), enableTilePartGeneration(), genPrecinctInfo(), genPrecinctInfoOPT(), genPrecinctX0Grid(), genPrecinctY0Grid(), get_include(), init(), isWholeTile(), next_pcrl(), skipPackets(), update_include(), and validatePrecinct().

## precinctIndex

uint64_t grk::PacketIter::precinctIndex

private

Referenced by generatePrecinctIndex(), getPrecinctIndex(), next_cprlOPT(), next_lrcp(), next_lrcpOPT(), next_pcrlOPT(), next_rlcp(), next_rlcpOPT(), next_rpclOPT(), printDynamicState(), and update_include().

## precinctInfoOPT_

ResPrecinctInfo* grk::PacketIter::precinctInfoOPT_

private

Referenced by genPrecinctInfoOPT(), init(), next_cprl(), next_cprlOPT(), next_lrcp(), next_lrcpOPT(), next_pcrl(), next_pcrlOPT(), next_rlcp(), next_rlcpOPT(), next_rpcl(), next_rpclOPT(), printDynamicState(), printStaticState(), validatePrecinct(), and ~PacketIter().

## prog

grk_progression grk::PacketIter::prog

private

Referenced by checkForRemainingValidProgression(), enableTilePartGeneration(), genPrecinctInfoOPT(), getProgression(), init(), next(), next_cprl(), next_cprlOPT(), next_lrcp(), next_lrcpOPT(), next_pcrl(), next_pcrlOPT(), next_rlcp(), next_rlcpOPT(), next_rpcl(), next_rpclOPT(), PacketIter(), and printStaticState().

## px0grid_

uint32_t grk::PacketIter::px0grid_

private

Referenced by generatePrecinctIndex(), genPrecinctX0Grid(), genPrecinctX0GridPCRL_OPT(), genPrecinctX0GridRPCL_OPT(), next_cprlOPT(), next_pcrlOPT(), and next_rpclOPT().

## py0grid_

uint32_t grk::PacketIter::py0grid_

private

Referenced by generatePrecinctIndex(), genPrecinctY0Grid(), genPrecinctY0GridPCRL_OPT(), genPrecinctY0GridRPCL_OPT(), next_cprlOPT(), next_pcrlOPT(), and next_rpclOPT().

## resno

uint8_t grk::PacketIter::resno

private

Referenced by generatePrecinctIndex(), genPrecinctInfoOPT(), get_include(), getResno(), init(), next_cprl(), next_cprlOPT(), next_lrcp(), next_lrcpOPT(), next_pcrl(), next_pcrlOPT(), next_rlcp(), next_rlcpOPT(), next_rpcl(), next_rpclOPT(), precInfoCheck(), printDynamicState(), printStaticState(), update_dxy_for_comp(), update_include(), and validatePrecinct().

## singleProgression_

bool grk::PacketIter::singleProgression_

private

Referenced by genPrecinctInfoOPT(), init(), next_pcrl(), and update_include().

## skippedLeft_

bool grk::PacketIter::skippedLeft_

private

Referenced by next_rpclOPT().

## x

uint64_t grk::PacketIter::x

private

packet coordinates

Referenced by genPrecinctX0Grid(), genPrecinctX0GridPCRL_OPT(), genPrecinctX0GridRPCL_OPT(), init(), next_cprl(), next_cprlOPT(), next_pcrl(), next_pcrlOPT(), next_rpcl(), next_rpclOPT(), printDynamicState(), update_dxy(), and update_dxy_for_comp().

## y

uint64_t grk::PacketIter::y

private

Referenced by genPrecinctY0Grid(), genPrecinctY0GridPCRL_OPT(), genPrecinctY0GridRPCL_OPT(), init(), next_cprl(), next_cprlOPT(), next_pcrl(), next_pcrlOPT(), next_rpcl(), next_rpclOPT(), printDynamicState(), update_dxy(), and update_dxy_for_comp().

The documentation for this struct was generated from the following files:

- PacketIter.h
- PacketIter.cpp